<template>
  <div id="chatapp">
    <mainNavBar></mainNavBar>
    <div class="container">
      <div class="col-lg-6 offset-lg-3">
        <div v-if="!ready">
          <h1>Choisis ton Pseudo</h1>
          <form @submit.prevent="addUser">
            <div class="form-group row">
              <input
                type="text"
                class="form-control col-9"
                v-model="username"
                placeholder="Entrer votre pseudo ici"
              />
              <input
                type="submit"
                value="Join"
                class="btn btn-sm btn-info ml-1"
              />
            </div>
          </form>
        </div>
        <h2 v-else>{{ username }}</h2>
        <div class="card bg-info" v-if="ready">
          <div class="card-header text-white">
            <h4>
              Chat de la Team VDB<span class="float-right"
                >{{ connections }} connectés</span
              >
            </h4>
            <div v-if="ready">
              <p v-for="(user, index) in info" :key="index">
                {{ user.username }} {{ user.type }}
              </p>
            </div>
          </div>
          <ul class="list-group list-group-flush text-right">
            <small v-if="typing" class="text-white"
              >{{ typing }} écrit...</small
            >
            <li
              class="list-group-item"
              v-for="(message, index) in messages"
              :key="index"
            >
              <span :class="{ 'float-left': message.type === 1 }">
                {{ message.message }}
                <small>:{{ message.user }}</small>
              </span>
            </li>
          </ul>

          <div class="card-body">
            <form @submit.prevent="send">
              <div class="form-group">
                <input
                  type="text"
                  class="form-control"
                  v-model="newMessage"
                  placeholder="Enter message here"
                />
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { io } from "socket.io-client";
import mainNavBar from "../layout/mainNavBar.vue";

export default {
  name: "Chat",
  components: {
    mainNavBar,
  },
  // ******************************************************************************************
  // *                 Configuration coté client                                              *
  // ******************************************************************************************
  data() {
    return {
      newMessage: null,
      messages: [],
      typing: false,
      username: null,
      ready: false,
      info: [],
      connections: 0,
      io: null,
    };
  },

  created() {
    this.io = io("http://localhost:3000");
    window.onbeforeunload = () => {
      this.io.emit("leave", this.username);
    };
// Ecoute des messages envoyés
    this.io.on("chat-message", (data) => {
      this.messages.push({
        message: data.message,
        type: 1,
        user: data.user,
      });
    });
// Quand un utilisateur écrit
    this.io.on("typing", (data) => {
      this.typing = data;
    });

    this.io.on("stopTyping", () => {
      this.typing = false;
    });
// Quand un utilisateur se connecte
    this.io.on("joined", (data) => {
      this.info.push({
        username: data,
        type: "à rejoint le tchat",
      });

      setTimeout(() => {
        this.info = [];
      }, 10000);
    });
// Quand un utilisateur se deconnecte
    this.io.on("leave", (data) => {
      this.info.push({
        username: data,
        type: "est déconnecté",
      });

      setTimeout(() => {
        this.info = [];
      }, 10000);
    });
// Quand un utilisateur se connecte au serveur
    this.io.on("connections", (data) => {
      console.log(data);
      this.connections = data;
    });
  },
  updated() {
    this.io.on("connections", (data) => {
      console.log(data);
      this.connections = data;
    });
  },

  watch: {
    newMessage(value) {
      value
        ? this.io.emit("typing", this.username)
        : this.io.emit("stopTyping");
    },
  },

  methods: {
    // envoyer un message
    send() {
      this.messages.push({
        message: this.newMessage,
        type: 0,
        user: "Me",
      });

      this.io.emit("chat-message", {
        message: this.newMessage,
        user: this.username,
      });
      this.newMessage = null;
    },
  // quand un utilisateur se connecte
    addUser() {
      this.ready = true;
      this.io.emit("joined", this.username);
    },
  },
};
</script>

<style lang="scss" scoped>
h2 {
  color: #1b445a;
}
h1 {
  font-family: "BlueEyes";
}
.big {
  font-family: "BrighlyCrush";
  font-weight: 1100;
}
</style>
